require "json"
require "api/filters/version"

require "api/filters/condition"
require "api/filters/between"
require "api/filters/equal_to"
require "api/filters/greater_equal_than"
require "api/filters/greater_than"
require "api/filters/in"
require "api/filters/lower_equal_than"
require "api/filters/lower_than"
require "api/filters/query"

module Api
  module Filters

    def self.parse(string)
      if string
        filters = Hash.new
        filters.compare_by_identity
        filters[string.split("|").map { |f| f.split("::") }.each { |f| filters[f.first] = f.last }]
        return filters
      end

      {}
    end

    def self.condition(field, value)
      [Between, EqualTo, GreaterEqualThan, GreaterThan, In, LowerEqualThan, LowerThan].each do |condition|
        if condition.handle? value
          return condition.new(field, value).elastic_query if condition.new(field, value).respond_to? :elastic_query
        end
      end
    end

  end
end
