module Api
  module Filters
    class Between
      include Api::Filters::Condition

      condition_name "bt"

      def build_param
        { @field => extract_param }
      end

      def elastic_query
        param = @condition.match(/\((.*),(.*)\)/)
        { range: { :"#{@field}" => { gte: "#{param[1]}", lte: "#{param[2]}" } } }
      end

      def extract_param
        query_param = @condition.match(/\((.*),(.*)\)/)
        query_param[1]..query_param[2]
      end
    end
  end
end
