module Api
  module Filters
    class In
      include Api::Filters::Condition

      condition_name "in"

      def build_param
        { @field => extract_param }
      end

      def elastic_query
        { terms: { :"#{@field}" => extract_param } }
      end

      def extract_param
        query_param = @condition.match(/\((.*)\)/)
        query_param[1].split(",").map do |value|
          get_value(value)
        end.flatten.uniq
      end
    end
  end
end
